/*-----------------------------------------------------------------
  All code is provided for EDUCATIONAL purposes ONLY. There is no
  warranty and no support.

  Released under the MIT License  - see
  http://www.opensource.org/licenses/mit-license.php

  chimeclk by Jack Botner

  chimeclk.h
-----------------------------------------------------------------*/
#ifndef _CHIMECLK_H_
#define _CHIMECLK_H_

#include "common.h"

#define INIT_TIMER1			( 65536 - 10417 )
#define INIT_TIMER2			( 256 - 250 )

#define MAX_CHECKS       	8		// number of tests before a switch is debounced

#define LCD_MAINT_COUNT		27000	// 2.5 hours (1/3 second ticks)

// System modes bits
#define MODE_RUN			1
#define MODE_PROGRAM		2

// Main Menu Indexes
#define INDEX_RUN			0
#define INDEX_SETCLK		1
#define INDEX_ALARM			2
#define INDEX_ALARMTEST1	3
#define INDEX_ALARMTEST2	4
#define INDEX_CLKTEST		5

// Events bits (flags 1)
#define EVENT_UPDATE_LCD		0
#define EVENT_BUTTON_PRESSED	1
#define EVENT_ENCODER_UP		2
#define EVENT_ENCODER_DOWN		3
#define EVENT_READ_RTC			4
#define EVENT_SET_RTC			5
#define EVENT_LCD_MAINT			6

// Debounced switches bits
#define ENC_SWITCH_A			0
#define ENC_SWITCH_B			1
#define ENC_SWITCH_PB			2

// Rotary encoder port defines
#define ENCODER_PORT			PINB
#define ENCODER_A				PINB7
#define ENCODER_B				PINB6
#define ENCODER_PB				PINB2

// Functions

void program_clock( void );
void program_time( uint8_t ucRequest );

#endif  //_CHIMECLK_H_
