/*---------------------------------------------------------------------
  All code is provided for EDUCATIONAL purposes ONLY. There is no
  warranty and no support.

  Released under the MIT License  - see
  http://www.opensource.org/licenses/mit-license.php

  Module: nju6355.h
---------------------------------------------------------------------*/
#ifndef _NJU6355_H_
#define _NJU6355_H_

// Adjust the following depending on the clock speed in use

// 3 x 125ns = 375ns x 6 = 2.25us
#define RTC_Delay_2us()		_delay_loop_1( 6 )
// 4 x 125ns = 500ns x 20000 = 10ms
#define RTC_Delay_10ms()	_delay_loop_2( 20000 )

// Ports connected to NJU6355

#define RTC_DATA_DDR      DDRC
#define RTC_DATA_DDR_BIT  DDC0
#define RTC_DATA_PORT_IN  PINC
#define RTC_DATA_PORT_OUT PORTC
#define RTC_DATA_BIT      PORTC0

#define RTC_CLK_PORT      PORTC
#define RTC_CLK_BIT       PORTC2

#define RTC_IO_PORT       PORTC
#define RTC_IO_BIT        PORTC1

#define RTC_CE_PORT       PORTC
#define RTC_CE_BIT        PORTC3

// Real Time Clock parameters

typedef struct _RTCparms
{
  uint8_t rtc_year;
  uint8_t rtc_month;
  uint8_t rtc_day;
  uint8_t rtc_dayweek;
  uint8_t rtc_hours;
  uint8_t rtc_mins;
  uint8_t rtc_secs;
}
RTCPARMS;

// Functions

void rtc_init( void );
void rtc_read( void );
void rtc_test( void );
void rtc_write( void );

#endif  //_NJU6355_H_
